package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GrupoCategoriaDAO;
import com.rjconsultores.ventaboletos.entidad.GrupoCategoria;
import com.rjconsultores.ventaboletos.service.GrupoCategoriaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("grupoCategoriaService")
public class GrupoCategoriaServiceImpl implements GrupoCategoriaService {

	@Autowired
	private GrupoCategoriaDAO grupoCategoriaDAO;

	public List<GrupoCategoria> obtenerTodos() {
		return grupoCategoriaDAO.obtenerTodos();
	}

	public GrupoCategoria obtenerID(Integer id) {
		return grupoCategoriaDAO.obtenerID(id);
	}

	@Transactional
	public GrupoCategoria suscribir(GrupoCategoria entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return grupoCategoriaDAO.suscribir(entidad);
	}

	@Transactional
	public GrupoCategoria actualizacion(GrupoCategoria entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return grupoCategoriaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(GrupoCategoria entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		grupoCategoriaDAO.actualizacion(entidad);
	}

	@Override
	public List<GrupoCategoria> buscar(String descricao) {
		return grupoCategoriaDAO.buscar(descricao);
	}
}
